unit PrintPreviewUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, StdCtrls, Windows;

type

  { TPrintPreviewForm }

  TPrintPreviewForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    procedure PaintBox1Paint(Sender: TObject);
  private
    FEMF: THandle;
    { private declarations }
  public
    { public declarations }
    property EMF: THandle read FEMF write FEMF;
  end;

var
  PrintPreviewForm: TPrintPreviewForm;

implementation

{$R *.lfm}

{ TPrintPreviewForm }

procedure TPrintPreviewForm.PaintBox1Paint(Sender: TObject);
var
  DstRect, PaintRect: TRect;
  DstSize: TSize;
begin
  DstRect := PaintBox1.ClientRect;
  DstSize.cx := DstRect.Right - DstRect.Left;
  DstSize.cy := DstRect.Bottom - DstRect.Top;
  if(DstSize.cx * 297) > (DstSize.cy * 210)then
  begin
    PaintRect.Top := DstRect.Top;
    PaintRect.Bottom := DstRect.Bottom;
    PaintRect.Left := ((DstRect.Left + DstRect.Right) - DstSize.cy * 210 div 297) div 2;
    PaintRect.Right := ((DstRect.Left + DstRect.Right) + DstSize.cy * 210 div 297) div 2;
  end
  else
  begin
    PaintRect.Left := DstRect.Left;
    PaintRect.Right := DstRect.Right;
    PaintRect.Top := ((DstRect.Top + DstRect.Bottom) - DstSize.cx * 297 div 210) div 2;
    PaintRect.Bottom := ((DstRect.Top + DstRect.Bottom) + DstSize.cx * 297 div 210) div 2;
  end;


  PaintBox1.Canvas.Brush.Color := clWhite;
  PaintBox1.Canvas.FillRect(PaintRect);
  Windows.PlayEnhMetaFile(PaintBox1.Canvas.Handle, EMF, PaintRect);
  PaintBox1.Canvas.DrawFocusRect(PaintRect);
end;

end.

