unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, PrintersDlgs, Forms, Controls, Graphics, Dialogs,
  ComCtrls, ActnList, Menus, ExtCtrls, StdCtrls, Printers, ExtDlgs, LazUtf8Classes,
  Windows, MyDataUtils, CardUnit, CalendarUnit, FPCanvas, Math, Types;

type

  { TForm1 }

  TForm1 = class(TForm)
    Action_ViewZoomDown: TAction;
    Action_ViewZoomUp: TAction;
    Action_PageBackward: TAction;
    Action_PageForward: TAction;
    Action_EditShape: TAction;
    Action_EditAddShape: TAction;
    Action_EditSendToBack: TAction;
    Action_EditBringToFront: TAction;
    Action_EditDeleteItem: TAction;
    Action_EditAddImage: TAction;
    Action_EditAddLabel: TAction;
    Action_EditPicture: TAction;
    Action_EditLabel: TAction;
    Action_FileExport: TAction;
    Action_FilePrint: TAction;
    Action_FileExit: TAction;
    Action_FileSave: TAction;
    Action_FileOpen: TAction;
    ActionList1: TActionList;
    CheckBox_WeekNum: TCheckBox;
    CheckBox_JpnFiscalYear: TCheckBox;
    ColorDialog1: TColorDialog;
    ComboBox_Lang: TComboBox;
    ComboBox_Year: TComboBox;
    FontDialog1: TFontDialog;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label_Year: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem_Zoom: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem_EditShape: TMenuItem;
    MenuItem_EditAddShape: TMenuItem;
    MenuItem_AfterProperty: TMenuItem;
    MenuItem_EditBringToFront: TMenuItem;
    MenuItem_EditSendToBack: TMenuItem;
    MenuItem_AfterZOrder: TMenuItem;
    MenuItem_FileOpen: TMenuItem;
    MenuItem_FileSave: TMenuItem;
    MenuItem_EditDeleteItem: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem_EditAddItem: TMenuItem;
    MenuItem9: TMenuItem;
    MenuItem_EditPicture: TMenuItem;
    MenuItem_EditAddLabel: TMenuItem;
    MenuItem_EditAddImage: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem_EditLabel: TMenuItem;
    MenuItem_File: TMenuItem;
    OpenDialog_Data: TOpenDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    PageControl1: TPageControl;
    PaintBox_Card: TPaintBox;
    PaintBox_Resizer: TPaintBox;
    PaintBox_Calendar: TPaintBox;
    Panel1: TPanel;
    Panel_Card: TPanel;
    Panel_Calendar: TPanel;
    PopupMenu_Calendar: TPopupMenu;
    PopupMenu_Card: TPopupMenu;
    PrintDialog1: TPrintDialog;
    SaveDialog_Data: TSaveDialog;
    SaveDialog_Export: TSaveDialog;
    ScrollBox1: TScrollBox;
    Shape1: TShape;
    Shape2: TShape;
    StatusBar1: TStatusBar;
    TabSheet_Card: TTabSheet;
    TabSheet_Calendar: TTabSheet;
    procedure Action_EditAddImageExecute(Sender: TObject);
    procedure Action_EditAddLabelExecute(Sender: TObject);
    procedure Action_EditAddShapeExecute(Sender: TObject);
    procedure Action_EditBringToFrontExecute(Sender: TObject);
    procedure Action_EditDeleteItemExecute(Sender: TObject);
    procedure Action_EditLabelExecute(Sender: TObject);
    procedure Action_EditPictureExecute(Sender: TObject);
    procedure Action_EditSendToBackExecute(Sender: TObject);
    procedure Action_EditShapeExecute(Sender: TObject);
    procedure Action_FileExitExecute(Sender: TObject);
    procedure Action_FileExportExecute(Sender: TObject);
    procedure Action_FileOpenExecute(Sender: TObject);
    procedure Action_FilePrintExecute(Sender: TObject);
    procedure Action_FileSaveExecute(Sender: TObject);
    procedure Action_PageBackwardExecute(Sender: TObject);
    procedure Action_PageForwardExecute(Sender: TObject);
    procedure Action_ViewZoomDownExecute(Sender: TObject);
    procedure Action_ViewZoomUpExecute(Sender: TObject);
    procedure CheckBox_JpnFiscalYearChange(Sender: TObject);
    procedure CheckBox_WeekNumChange(Sender: TObject);
    procedure ComboBox_LangChange(Sender: TObject);
    procedure ComboBox_YearChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuItem_FileClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox_CalendarDblClick(Sender: TObject);
    procedure PaintBox_CalendarMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox_CalendarPaint(Sender: TObject);
    procedure PaintBox_CardClick(Sender: TObject);
    procedure PaintBox_CardDblClick(Sender: TObject);
    procedure PaintBox_CardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox_CardMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox_CardMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox_CardMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox_CardMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure PaintBox_CardPaint(Sender: TObject);
    procedure PaintBox_ResizerClick(Sender: TObject);
    procedure PaintBox_ResizerDblClick(Sender: TObject);
    procedure PaintBox_ResizerMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox_ResizerMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox_ResizerMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox_ResizerPaint(Sender: TObject);
    procedure Panel_CardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PopupMenu_CardPopup(Sender: TObject);
    procedure ScrollBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    FMyCard: TMyCard;
    function ClientToHiMetric(R: TRect): TRect;
    function HiMetricToClient(R: TRect): TRect;
    procedure DoPrint_Card_EMF;
    procedure DoPrint_Card;
    procedure DoPrint_Calendar_EMF;
    function DoSaveToFile(FileName: string): Boolean;
    function DoLoadFromFile(FileName: string): Boolean;
    function Add_MyCardLabel(Selected: Boolean = TRUE): TMyCardLabel;
    function Add_MyCardImage(Selected: Boolean = TRUE): TMyCardImage;
    function Add_MyCardShape(Selected: Boolean = TRUE): TMyCardShape;
  private
    FMouseDownPoint: TPoint;
    FMouseDownRect: TRect;
    procedure CardItem_MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CardItem_MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure CardItem_MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CardItem_Click(Sender: TObject);
    procedure CardItem_DblClick(Sender: TObject);
    procedure CardItem_Invalidate(Sender: TObject);
    procedure SetZoom_Card(AValue: Integer);
    procedure CardItem_PropertyChange(Sender: TObject);
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  PrintPreviewUnit, LabelPropertyUnit, ShapePropertyUnit;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
  E: Extended;
  ST: TSystemTime;
  iLogPixelsY: Integer;
  W, H: Integer;
  List: TList;
  Control: TControl;
  MyCardLabel: TMyCardLabel;
  MyCardImage: TMyCardImage;
  MyCardShape: TMyCardShape;
begin
  FMyCard := TMyCard.Create;
  Caption := Application.Title;

  Panel1.ClientWidth := Panel_Card.Width + Panel_Card.Left * 2;
  Panel1.ClientHeight := Panel_Card.Height + Panel_Card.Top * 2;

  Windows.GetLocalTime(ST);
  with ComboBox_Year do
  begin
    Items.Clear;
    if(ST.Month < 4) then // 1～3月は年度変わりの前なので、このようにしてみました。
      ST.Year := ST.Year - 1;
    //for I := -1 to 10 do
    for I := -5 to 20 do
      Items.Add(IntToStr(ST.Year + I));
    ItemIndex := 5;
  end;

  // 初期状態で名刺印刷パネルに配置されている
  // TLabel、TImage と TShape をそれぞれ、
  // TMyCardLabel と TMyCardImage に変換する
  iLogPixelsY:= GetDeviceCaps(Canvas.Handle, LOGPIXELSY);  // 縦１インチあたりのピクセル数

  W := Panel_Card.ClientWidth;
  H := Panel_Card.ClientHeight;

  List := TList.Create;
  try
    for I := 0 to Panel_Card.ControlCount - 1 do
      List.Add(Panel_Card.Controls[I]);
    for I := 0 to List.Count - 1 do
    begin
      Control := TControl(List[I]);
      if Control = PaintBox_Resizer then
      else if Control is TLabel then
      begin
        MyCardLabel := Add_MyCardLabel(FALSE);
        MyCardLabel.SetBounds(
          91 * 100 * Control.Left div W,
          55 * 100 * Control.Top div H,
          91 * 100 * Control.Width div W,
          55 * 100 * Control.Height div H);

        MyCardLabel.Font := Control.Font;
        E := H / iLogPixelsY * 25.4;
        E := E / 2; // 0.5ポイント単位で指定できるように、内部的に２倍数で記録
        MyCardLabel.Font.Size := Round(Control.Font.Size * (55 / E));

        MyCardLabel.Caption := Control.Caption;
        MyCardLabel.Alignment := TLabel(Control).Alignment;
        MyCardLabel.Layout := TLabel(Control).Layout;
        Control.Free;
      end
      else if Control is TImage then
      begin
        MyCardImage := Add_MyCardImage(FALSE);
        MyCardImage.SetBounds(
          91 * 100 * Control.Left div W,
          55 * 100 * Control.Top div H,
          91 * 100 * Control.Width div W,
          55 * 100 * Control.Height div H);
        MyCardImage.Picture.Assign(TImage(Control).Picture);
        Control.Free;
      end
      else if Control is TShape then
      begin
        MyCardShape := Add_MyCardShape(FALSE);
        MyCardShape.SetBounds(
          91 * 100 * Control.Left div W,
          55 * 100 * Control.Top div H,
          91 * 100 * Control.Width div W,
          55 * 100 * Control.Height div H);
        MyCardShape.Shape := Integer(TShape(Control).Shape);
        MyCardShape.Pen := TShape(Control).Pen;
        MyCardShape.Brush := TShape(Control).Brush;
        Control.Free;
      end;
    end;
  finally
    List.Free;
  end;
  PageControl1.ActivePageIndex := 0;
  PaintBox_Resizer.Hide;

  PaintBox_Card.Align := alClient;
  SetZoom_Card(10);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FMyCard.Free;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  S: string;
begin
  S := ExtractFilePath(Application.Exename) + 'Holidays.txt';
  if FileExists(S) then
    CalendarUnit.LoadHolidaysFromFile(S);
end;

procedure TForm1.MenuItem_FileClick(Sender: TObject);
begin
  if PageControl1.ActivePage = TabSheet_Card then
  begin
    Action_FileOpen.Enabled := TRUE;
    Action_FileSave.Enabled := TRUE;
  end
  else
  begin
    Action_FileOpen.Enabled := FALSE;
    Action_FileSave.Enabled := FALSE;
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  PaintBox: TPaintBox;
begin
  if Sender is TPaintBox then
  begin
    PaintBox := TPaintBox(Sender);
    PaintBox.Canvas.Brush.Style := bsClear;
    PaintBox.Canvas.Pen.Color := clLime;
    PaintBox.Canvas.Pen.Style := psDash;
    PaintBox.Canvas.Pen.Width := 2;
    PaintBox.Canvas.RoundRect(PaintBox.ClientRect, 10, 10);
  end;
end;

procedure TForm1.PaintBox_CalendarDblClick(Sender: TObject);
var
  ST: TSystemTime;
  I: Integer;
begin
  Windows.GetLocalTime(ST);
  with ComboBox_Year do
  begin
    if(ST.Month < 4) then // 1～3月は年度変わりの前なので、このようにしてみました。
      ST.Year := ST.Year - 1;
    for I := 0 to Items.Count - 1 do
    begin
      if StrToIntDef(Items[I], -1) = ST.Year then
      begin
        ItemIndex := I;
        if Assigned(OnChange) then
          OnChange(Self);
        break;
      end;
    end;
  end;
end;

procedure TForm1.PaintBox_CalendarMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  if WheelDelta > 0 then
  begin
    if ComboBox_Year.ItemIndex > 0 then
    begin
      ComboBox_Year.ItemIndex := ComboBox_Year.ItemIndex - 1;
      if Assigned(ComboBox_Year.OnChange) then
        ComboBox_Year.OnChange(Self);
    end;
  end
  else if WheelDelta < 0 then
  begin
    if ComboBox_Year.ItemIndex < (ComboBox_Year.Items.Count - 1) then
    begin
      ComboBox_Year.ItemIndex := ComboBox_Year.ItemIndex + 1;
      if Assigned(ComboBox_Year.OnChange) then
        ComboBox_Year.OnChange(Self);
    end;
  end;
end;

procedure TForm1.PaintBox_CalendarPaint(Sender: TObject);
var
  DstRect, PaintRect: TRect;
  DstSize: TSize;
  EMF: THandle;
  MyCalendar: TMyCalendar;
begin
  DstRect := PaintBox_Calendar.ClientRect;
  DstSize.cx := DstRect.Right - DstRect.Left;
  DstSize.cy := DstRect.Bottom - DstRect.Top;
  if(DstSize.cx * 297) > (DstSize.cy * 210)then
  begin
    PaintRect.Top := DstRect.Top;
    PaintRect.Bottom := DstRect.Bottom;
    PaintRect.Left := ((DstRect.Left + DstRect.Right) - DstSize.cy * 210 div 297) div 2;
    PaintRect.Right := ((DstRect.Left + DstRect.Right) + DstSize.cy * 210 div 297) div 2;
  end
  else
  begin
    PaintRect.Left := DstRect.Left;
    PaintRect.Right := DstRect.Right;
    PaintRect.Top := ((DstRect.Top + DstRect.Bottom) - DstSize.cx * 297 div 210) div 2;
    PaintRect.Bottom := ((DstRect.Top + DstRect.Bottom) + DstSize.cx * 297 div 210) div 2;
  end;

  PaintBox_Calendar.Canvas.Brush.Color := clWhite;
  PaintBox_Calendar.Canvas.FillRect(PaintRect);
  try
    MyCalendar := TMyCalendar.Create(StrToIntDef(ComboBox_Year.Text, 0));
    try
      MyCalendar.Lang := ComboBox_Lang.ItemIndex;
      MyCalendar.WeekNum := CheckBox_WeekNum.Checked;
      MyCalendar.JpnFiscalYear := CheckBox_JpnFiscalYear.Checked;
      EMF := MyCalendar.MakeEMF;
    finally
      MyCalendar.Free;
    end;
    Windows.PlayEnhMetaFile(PaintBox_Calendar.Canvas.Handle, EMF, PaintRect);
  finally
    DeleteEnhMetaFile(EMF);
  end;

  PaintBox_Calendar.Canvas.DrawFocusRect(PaintRect);
end;

procedure TForm1.PaintBox_CardClick(Sender: TObject);
var
  pt: TPoint;
  I: Integer;
  MyCardItem: TMyCardItem;
  R: TRect;
begin
  pt := PaintBox_Card.ScreenToClient(Mouse.CursorPos);
  // 0.01mm単位に変換
  pt.x := Round(9100 * pt.x / PaintBox_Card.ClientWidth);
  pt.y := Round(5500 * pt.y / PaintBox_Card.ClientHeight);
  StatusBar1.SimpleText := '';
  for I := FMyCard.Count - 1 downto 0 do
  begin
    MyCardItem := FMyCard[I];
    R := MyCardItem.BoundsRect;
    if(pt.x >= R.Left)and(pt.x < R.Right)and(pt.y >= R.Top)and(pt.y < R.Bottom)then
    begin
      if Assigned(MyCardItem.OnClick) then
      begin
        MyCardItem.OnClick(MyCardItem);
        StatusBar1.SimpleText := MyCardItem.ClassName;
      end;
      break;
    end;
  end;
end;

procedure TForm1.PaintBox_CardDblClick(Sender: TObject);
var
  pt: TPoint;
  I: Integer;
  MyCardItem: TMyCardItem;
  R: TRect;
begin
  pt := PaintBox_Card.ScreenToClient(Mouse.CursorPos);
  // 0.01mm単位に変換
  pt.x := Round(9100 * pt.x / PaintBox_Card.ClientWidth);
  pt.y := Round(5500 * pt.y / PaintBox_Card.ClientHeight);
  StatusBar1.SimpleText := '';
  for I := FMyCard.Count - 1 downto 0 do
  begin
    MyCardItem := FMyCard[I];
    R := MyCardItem.BoundsRect;
    if(pt.x >= R.Left)and(pt.x < R.Right)and(pt.y >= R.Top)and(pt.y < R.Bottom)then
    begin
      if Assigned(MyCardItem.OnDblClick) then
      begin
        MyCardItem.OnDblClick(MyCardItem);
      end;
      break;
    end;
  end;
end;

procedure TForm1.PaintBox_CardMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  pt: TPoint;
  I: Integer;
  MyCardItem: TMyCardItem;
  R: TRect;
begin
  // 0.01mm単位に変換
  pt.x := Round(9100 * X / PaintBox_Card.ClientWidth);
  pt.y := Round(5500 * Y / PaintBox_Card.ClientHeight);
  for I := FMyCard.Count - 1 downto 0 do
  begin
    MyCardItem := FMyCard[I];
    R := MyCardItem.BoundsRect;
    if(pt.x >= R.Left)and(pt.x < R.Right)and(pt.y >= R.Top)and(pt.y < R.Bottom)then
    begin
      if Assigned(MyCardItem.OnMouseDown) then
      begin
        MyCardItem.OnMouseDown(MyCardItem, Button, Shift, pt.X, pt.Y);
      end;
      break;
    end;
    if I = 0 then
    begin
      FMyCard.SelectedItem := nil;
      PaintBox_Resizer.Hide;
    end;
  end;
end;

procedure TForm1.PaintBox_CardMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  pt: TPoint;
  I: Integer;
  MyCardItem: TMyCardItem;
  R: TRect;
begin
  // 0.01mm単位に変換
  pt.x := Round(9100 * X / PaintBox_Card.ClientWidth);
  pt.y := Round(5500 * Y / PaintBox_Card.ClientHeight);
  for I := FMyCard.Count - 1 downto 0 do
  begin
    MyCardItem := FMyCard[I];
    R := MyCardItem.BoundsRect;
    if(pt.x >= R.Left)and(pt.x < R.Right)and(pt.y >= R.Top)and(pt.y < R.Bottom)then
    begin
      if Assigned(MyCardItem.OnMouseMove) then
      begin
        MyCardItem.OnMouseMove(MyCardItem, Shift, pt.X, pt.Y);
      end;
      break;
    end;
  end;// for I := FCardItems.Count - 1 downto 0 do
end;

procedure TForm1.PaintBox_CardMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  pt: TPoint;
  I: Integer;
  MyCardItem: TMyCardItem;
  R: TRect;
begin
  // 0.01mm単位に変換
  pt.x := Round(9100 * X / PaintBox_Card.ClientWidth);
  pt.y := Round(5500 * Y / PaintBox_Card.ClientHeight);
  for I := FMyCard.Count - 1 downto 0 do
  begin
    MyCardItem := FMyCard[I];
    R := MyCardItem.BoundsRect;
    if(pt.x >= R.Left)and(pt.x < R.Right)and(pt.y >= R.Top)and(pt.y < R.Bottom)then
    begin
      if Assigned(MyCardItem.OnMouseUp) then
      begin
        MyCardItem.OnMouseUp(MyCardItem, Button, Shift, pt.X, pt.Y);
      end;
      break;
    end;
  end;
end;

procedure TForm1.PaintBox_CardMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  //if GetKeyShiftState = [ssCtrl] then
  begin
    Action_ViewZoomDown.Execute;
    Handled := TRUE;
  end;
end;

procedure TForm1.PaintBox_CardMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  //if GetKeyShiftState = [ssCtrl] then
  begin
    Action_ViewZoomUp.Execute;
    Handled := TRUE;
  end;
end;

procedure TForm1.PaintBox_CardPaint(Sender: TObject);
var
  DC: HDC;
  SaveIndex: Integer;
  W, H: Integer;
begin
  DC := PaintBox_Card.Canvas.Handle;
  SaveIndex := Windows.SaveDC(DC);
  try
    W := PaintBox_Card.ClientWidth;
    H := PaintBox_Card.ClientHeight;

    if Windows.SetMapMode(DC, MM_ANISOTROPIC) = 0 then
      // SetMapModeが失敗
    else if Windows.SetViewportExtEx(DC, W, H, nil) = FALSE then
      // SetViewportExtExが失敗
    else if Windows.SetWindowExtEx(DC, 91 * 100, 55 * 100, nil) = FALSE then
      // SetWindowExtExが失敗
    else
      FMyCard.DoPrint_SingleCard(DC);

    // 製品クラスの信頼性を得るには、上記の各関数が返すエラーもちゃんと拾いましょう。

  finally
    Windows.RestoreDC(DC, SaveIndex);
  end;
end;

procedure TForm1.PaintBox_ResizerClick(Sender: TObject);
var
  pt: TPoint;
  List: TList;
  I: Integer;
  MyCardItem: TMyCardItem;
  R: TRect;
begin
  if GetKeyShiftState = [ssShift] then // Shiftキーを条件から外すと、自分の操作感には合わないです
  if PaintBox_Resizer.Visible and Assigned(FMyCard.SelectedItem) then
  begin
    List := TList.Create;
    try
      // マウスの位置にある描画項目のリストを作成する
      pt := PaintBox_Card.ScreenToClient(Mouse.CursorPos);
      // 0.01mm単位に変換
      pt.x := Round(9100 * pt.x / PaintBox_Card.ClientWidth);
      pt.y := Round(5500 * pt.y / PaintBox_Card.ClientHeight);
      for I := FMyCard.Count - 1 downto 0 do
      begin
        MyCardItem := FMyCard[I];
        R := MyCardItem.BoundsRect;
        if(pt.x >= R.Left)and(pt.x < R.Right)and(pt.y >= R.Top)and(pt.y < R.Bottom)then
        begin
          List.Add(MyCardItem);
        end;
      end;

      // マウスの位置にある描画項目のリストの中から、
      // 選択中の描画項目の "次の" 描画項目を選択状態にする
      I := List.IndexOf(FMyCard.SelectedItem);
      if(List.Count > 1)and(I >= 0)then
      begin
        if(I < (List.Count - 1)) then
          MyCardItem := TMyCardItem(List[I + 1])
        else
          MyCardItem := TMyCardItem(List[0]);
        FMyCard.SelectedItem := MyCardItem;
        R := MyCardItem.BoundsRect;
        R.Left := R.Left * PaintBox_Card.ClientWidth div 9100;
        R.Top := R.Top * PaintBox_Card.ClientHeight div 5500;
        R.Right := R.Right * PaintBox_Card.ClientWidth div 9100;
        R.Bottom := R.Bottom * PaintBox_Card.ClientHeight div 5500;
        R.Right := R.Right + 1; R.Bottom := R.Bottom + 1;
        PaintBox_Resizer.BoundsRect := R;
        PaintBox_Resizer.BringToFront;
        PaintBox_Resizer.Show;
      end
      else
      begin
        // "次" に選択状態にする描画項目が無ければ、非選択状態にする
        FMyCard.SelectedItem := nil;
        PaintBox_Resizer.Hide;
      end;

    finally
      List.Free;
    end;
  end;
end;

procedure TForm1.PaintBox_ResizerDblClick(Sender: TObject);

  procedure _BUG_Workaround_();
  var
    dwTickCount: DWORD;
  const
    _OPTION_ = 0;
  begin
    // ダブルクリックのイベントから
    // プロパティ編集ダイアログを表示＆閉じた直後に、
    // 描画項目のリサイズ（特に拡大）を行おうとすると、
    // マウスイベントをつかみ損ねる現象（Lazarus1.6.0のバグ？）
    // を回避するための方策です。
    // 描画項目の右クリックメニューからプロパティ編集ダイアログを
    // 表示＆閉じた場合は、この不具合は出ないようです。
    case _OPTION_ of
    0:begin // 不具合を回避できました
        dwTickCount := Windows.GetTickCount;
        repeat
          Sleep(0);
          Application.ProcessMessages;
        until (Windows.GetTickCount - dwTickCount) > 400;
        // 手元のテスト環境では "> 200" で不具合が回避できましたが、
        // 念のため、操作に違和感の生じない範囲で長めにしました。
      end;
    1:begin // 不具合を回避できました
        Sleep(400);
        Application.ProcessMessages();
        // 手元のテスト環境では、この２行だけでも不具合を回避できましたが、
        // 心配性（？）の私は repeat を用いる不具合回避コードを用います。
      end;
    2: Application.ProcessMessages(); // 不具合が発生
    3: Sleep(400); // 不具合が発生
    4:begin // 不具合が発生
        Application.ProcessMessages();
        Sleep(400);
      end;
    end; // case _OPTION_ of
  end;
begin
  with PaintBox_Resizer do
  begin
    Tag := 0;
    Cursor := crDefault;

    // 不具合を回避するための対策です。
    _BUG_Workaround_();

    if FMyCard.SelectedItem = nil then
      //
    else if FMyCard.SelectedItem is TMyCardLabel then
      Action_EditLabel.Execute
    else if FMyCard.SelectedItem is TMyCardImage then
      Action_EditPicture.Execute
    else if FMyCard.SelectedItem is TMyCardShape then
      Action_EditShape.Execute;

    // ダイアログ表示後に実行しても不具合が回避できないようです。
    // _BUG_Workaround_();
  end;
end;

procedure TForm1.PaintBox_ResizerMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  with PaintBox_Resizer do
  begin
    FMouseDownPoint := ClientToScreen(Classes.Point(X, Y));
    FMouseDownRect := BoundsRect;

    // 四隅でマウスが押されたら、MouseMoveイベントでサイズ変更処理をするため
    // Tag に記録する
    if(X < 8)and(Y < 8)then
      Tag := 1
    else if(X >= (Width - 8))and(Y < 8)then
      Tag := 3
    else if(X >= (Width - 8))and(Y >= (Height - 8))then
      Tag := 5
    else if(X < 8)and(Y >= (Height - 8))then
      Tag := 7
    else if Y < 8 then // 上側
      Tag := 2
    else if X >= (Width - 8) then // 右側
      Tag := 4
    else if Y >= (Height - 8) then // 下側
      Tag := 6
    else if X < 8 then //　左側
      Tag := 8
    else
    begin
      Tag := -1;
      Cursor := crSizeAll;
    end;
  end;// with TMyCardItem(Sender) do
end;

procedure TForm1.PaintBox_ResizerMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  ptMouse: TPoint;
  dX, dY: Integer;
  R, RHiMetric: TRect;
var
  MyCardItem: TMyCardItem;

  procedure _Limit;
  begin
    if R.Left < 0 then
      R.Left := 0;
    if R.Top < 0 then
      R.Top := 0;
    if R.Right > PaintBox_Card.Width then
      R.Right := PaintBox_Card.Width;
    if R.Bottom > PaintBox_Card.Height then
      R.Bottom := PaintBox_Card.Height;
  end;
  procedure _Proc(var R: TRect);
  const
    //_Coef = 8;
    _Coef = 100;
    _Half = _Coef div 2;
  begin
    if ssAlt in Shift then Exit;
    R.Left   := (R.Left   + _Half) div _Coef * _Coef;
    R.Right  := (R.Right  + _Half) div _Coef * _Coef;
    R.Top    := (R.Top    + _Half) div _Coef * _Coef;
    R.Bottom := (R.Bottom + _Half) div _Coef * _Coef;
  end;
begin
  with PaintBox_Resizer do
  begin
    //if Tag = 0 then
    if (Windows.GetKeyState(VK_LBUTTON) and $8000) = 0 then
    begin
      // マウス左ボタンがUp状態
      Tag := 0;

      if(X < 8)and(Y < 8)then
        Cursor := crSizeNWSE
      else if(X < 8)and(Y >= (Height - 8))then
        Cursor := crSizeNESW
      else if(X >= (Width - 8))and(Y >= (Height - 8))then
        Cursor := crSizeNWSE
      else if(X >= (Width - 8))and(Y < 8)then
        Cursor := crSizeNESW
      else if Y < 8 then // 上側
        Cursor := crSizeNS
      else if X >= (Width - 8) then // 右側
        Cursor := crSizeWE
      else if Y >= (Height - 8) then // 下側
        Cursor := crSizeNS
      else if X < 8 then // 左側
        Cursor := crSizeWE
      else
        Cursor := crDefault;
    end
    else
    begin
      // マウス左ボタンがDown状態

      // 移動量を算出（スクリーン上のピクセル数）
      ptMouse := ClientToScreen(Classes.Point(X, Y));
      dX := ptMouse.x - FMouseDownPoint.x;
      dY := ptMouse.y - FMouseDownPoint.y;

      case Tag of
      -1:begin
          Cursor := crSizeAll;
          R := FMouseDownRect;
          OffsetRect(R, dX, dY);
          if R.Left < 0 then
            OffsetRect(R, -R.Left, 0);
          if R.Top < 0 then
            OffsetRect(R, 0, -R.Top);
          if R.Right > Parent.Width then
            OffsetRect(R, Parent.Width - R.Right, 0);
          if R.Bottom > Parent.Height then
            OffsetRect(R, 0, Parent.Height - R.Bottom);
        end;
      1:begin
          Cursor := crSizeNWSE;
          R := FMouseDownRect;
          R.Left := R.Left + dX;
          R.Top := R.Top + dY;
          if(R.Right - R.Left) < 32 then
            R.Left := R.Right - 32;
          if(R.Bottom - R.Top) < 32 then
            R.Top := R.Bottom - 32;
          _Limit;
        end;
      3:begin
          Cursor := crSizeNESW;
          R := FMouseDownRect;
          R.Right := R.Right + dX;
          R.Top := R.Top + dY;
          if(R.Right - R.Left) < 32 then
            R.Right := R.Left + 32;
          if(R.Bottom - R.Top) < 32 then
            R.Top := R.Bottom - 32;
          _Limit;
        end;
      5:begin
          Cursor := crSizeNWSE;
          R := FMouseDownRect;
          R.Right := R.Right + dX;
          R.Bottom := R.Bottom + dY;
          if(R.Right - R.Left) < 32 then
            R.Right := R.Left + 32;
          if(R.Bottom - R.Top) < 32 then
            R.Bottom := R.Top + 32;
          _Limit;
        end;
      7:begin
          Cursor := crSizeNESW;
          R := FMouseDownRect;
          R.Left := R.Left + dX;
          R.Bottom := R.Bottom + dY;
          if(R.Right - R.Left) < 32 then
            R.Left := R.Right - 32;
          if(R.Bottom - R.Top) < 32 then
            R.Bottom := R.Top + 32;
          _Limit;
        end;
      2:begin // 上側
          Cursor := crSizeNS;
          R := FMouseDownRect;
          R.Top := R.Top + dY;
          if(R.Bottom - R.Top) < 32 then
            R.Top := R.Bottom - 32;
          _Limit;
        end;
      4:begin // 右側
          Cursor := crSizeWE;
          R := FMouseDownRect;
          R.Right := R.Right + dX;
          if(R.Right - R.Left) < 32 then
            R.Right := R.Left + 32;
          _Limit;
        end;
      6:begin // 下側
          Cursor := crSizeNS;
          R := FMouseDownRect;
          R.Bottom := R.Bottom + dY;
          if(R.Bottom - R.Top) < 32 then
            R.Bottom := R.Top + 32;
          _Limit;
        end;
      8:begin // 左側
          Cursor := crSizeWE;
          R := FMouseDownRect;
          R.Left := R.Left + dX;
          if(R.Right - R.Left) < 32 then
            R.Left := R.Right - 32;
          _Limit;
        end;
      else
        begin
          Cursor := crDefault;
          RHiMetric := Classes.Rect(0, 0, 0, 0);
        end;
      end;

      MyCardItem := FMyCard.SelectedItem;
      if Assigned(MyCardItem) then
      begin
        RHiMetric := ClientToHiMetric(R);
        _Proc(RHiMetric);
        if(RHiMetric.Left < RHiMetric.Right)and(RHiMetric.Top < RHiMetric.Bottom)then
          MyCardItem.BoundsRect := RHiMetric;
        R := HiMetricToClient(RHiMetric);
        R.Bottom := R.Bottom + 1;
        R.Right := R.Right + 1;
        BoundsRect := R;
      end;
    end; // else of if Tag = 1
  end;// with PaintBox_Resizer
end;

procedure TForm1.PaintBox_ResizerMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // 移動・変形するマウス操作を終了
  with PaintBox_Resizer do
  begin
    Tag := 0;
    Cursor := crDefault;
  end;
end;

procedure TForm1.PaintBox_ResizerPaint(Sender: TObject);
begin
  with PaintBox_Resizer do
  begin
    Canvas.Pen.Color := clBlack;
    Canvas.Pen.Width := 2;
    Canvas.Pen.Style := psDash;
    Canvas.Pen.Mode := pmNotXor;
    Canvas.Brush.Style := bsClear;
    Canvas.Rectangle(1, 1, Width, Height);
  end;
end;

procedure TForm1.Panel_CardMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FMyCard.SelectedItem := nil;
  PaintBox_Resizer.Hide;
end;

procedure TForm1.PopupMenu_CardPopup(Sender: TObject);
var
  MyCardItem: TMyCardItem;
begin
  MyCardItem := FMyCard.SelectedItem;
  MenuItem_EditLabel.Visible := Assigned(MyCardItem) and (MyCardItem is TMyCardLabel);
  MenuItem_EditPicture.Visible := Assigned(MyCardItem) and (MyCardItem is TMyCardImage);
  MenuItem_EditShape.Visible := Assigned(MyCardItem) and (MyCardItem is TMyCardShape);
  MenuItem_AfterProperty.Visible := Assigned(MyCardItem);
  MenuItem_EditBringToFront.Visible := Assigned(MyCardItem);
  MenuItem_EditSendToBack.Visible := Assigned(MyCardItem);
  MenuItem_AfterZOrder.Visible := Assigned(MyCardItem);
  MenuItem_EditDeleteItem.Visible := Assigned(MyCardItem);
  if PageControl1.ActivePage = TabSheet_Card then
  begin
    Action_FileOpen.Enabled := TRUE;
    Action_FileSave.Enabled := TRUE;
  end
  else
  begin
    Action_FileOpen.Enabled := FALSE;
    Action_FileSave.Enabled := FALSE;
  end;
end;

procedure TForm1.ScrollBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FMyCard.SelectedItem := nil;
  PaintBox_Resizer.Hide;
end;

function TForm1.ClientToHiMetric(R: TRect): TRect;
begin
  Result.Left := Round(R.Left * 9100 / PaintBox_Card.ClientWidth);
  Result.Top := Round(R.Top * 5500 / PaintBox_Card.ClientHeight);
  Result.Right := Round(R.Right * 9100 / PaintBox_Card.ClientWidth);
  Result.Bottom := Round(R.Bottom * 5500 / PaintBox_Card.ClientHeight);
end;

function TForm1.HiMetricToClient(R: TRect): TRect;
begin
  Result.Left := Round(R.Left / 9100 * PaintBox_Card.ClientWidth);
  Result.Top := Round(R.Top / 5500 * PaintBox_Card.ClientHeight);
  Result.Right := Round(R.Right / 9100 * PaintBox_Card.ClientWidth);
  Result.Bottom := Round(R.Bottom / 5500 * PaintBox_Card.ClientHeight);
end;

procedure TForm1.DoPrint_Card_EMF;
var
  EMF: THandle;
  R, PrintRect: TRect;
  W, H: Extended;
begin
  try
    EMF := FMyCard.MakeEMF();

    PrintPreviewForm.EMF := EMF;
    if PrintPreviewForm.ShowModal = mrOk then
    begin
      if PrintDialog1.Execute then
      begin
        R := Printer.PaperSize.PaperRect.PhysicalRect;
        W := R.Right - R.Left; // ピクセル数
        H := R.Bottom - R.Top; // ピクセル数
        W := W / GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSX) * 25.4;
        H := H / GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSY) * 25.4;
        if(Round(W) <> 210)or(Round(H) <> 297)then
        begin
          Application.MessageBox(PChar(
            Format('用紙サイズがA4ではありません（%.1fmm x %.1fmm）', [H, W]) + #13#10 +
            '印刷を中止します。'),
            PChar('名刺の印刷'),
            MB_ICONERROR or MB_OK);
          Exit;
        end;

        Printer.BeginDoc;
        try
          // 端っこの非印刷領域も合わせてA4サイズなので、
          // 用紙の端までの領域を計算する
          PrintRect := Printer.PaperSize.PaperRect.PhysicalRect;
          OffsetRect(PrintRect,
            -Printer.PaperSize.PaperRect.WorkRect.Left,
            -Printer.PaperSize.PaperRect.WorkRect.Top);

          Windows.PlayEnhMetaFile(Printer.Canvas.Handle, EMF, PrintRect);
        finally
          Printer.EndDoc;
        end;
      end;
    end;
  finally
    Windows.DeleteEnhMetaFile(EMF);
  end;
end;

procedure TForm1.DoPrint_Card;
var
  R: TRect;
  W, H: Extended;
begin
  if PrintDialog1.Execute then
  begin
    R := Printer.PaperSize.PaperRect.PhysicalRect;
    W := R.Right - R.Left; // ピクセル数
    H := R.Bottom - R.Top; // ピクセル数
    W := W / GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSX) * 25.4;
    H := H / GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSY) * 25.4;
    if(Round(W) <> 210)or(Round(H) <> 297)then
    begin
      Application.MessageBox(PChar(
        Format('用紙サイズがA4ではありません（%.1fmm x %.1fmm）', [H, W]) + #13#10 +
        '印刷を中止します。'),
        PChar('名刺の印刷'),
        MB_ICONERROR or MB_OK);
      Exit;
    end;

    Printer.BeginDoc;
    try
      FMyCard.DoPrint(Printer.Canvas.Handle,
        -Printer.PaperSize.PaperRect.WorkRect.Left,
        -Printer.PaperSize.PaperRect.WorkRect.Top);

    finally
      Printer.EndDoc;
    end;
  end;
end;

procedure TForm1.DoPrint_Calendar_EMF;
var
  EMF: THandle;
  MyCalendar: TMyCalendar;
  R, PrintRect: TRect;
  W, H: Extended;
  bProportional: Boolean;
begin
  if PrintDialog1.Execute then
  begin
    R := Printer.PaperSize.PaperRect.PhysicalRect;
    W := R.Right - R.Left; // ピクセル数
    H := R.Bottom - R.Top; // ピクセル数
    W := W / GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSX) * 25.4;
    H := H / GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSY) * 25.4;
    bProportional := FALSE;
    if(Round(W) <> 210)or(Round(H) <> 297)then
    begin
      if Application.MessageBox(PChar(
        Format('用紙サイズがA4ではありません（%.1fmm x %.1fmm）', [H, W]) + #13#10 +
        '用紙サイズに合わせて伸縮して印刷しますか？'),
        PChar('カレンダーの印刷'),
        MB_ICONWARNING or MB_YESNO or MB_DEFBUTTON2) = IDYES then
        bProportional := TRUE
      else
        Exit;
    end;

    try
      MyCalendar := TMyCalendar.Create(StrToIntDef(ComboBox_Year.Text, 0));
      try
        MyCalendar.Lang := ComboBox_Lang.ItemIndex;
        MyCalendar.WeekNum := CheckBox_WeekNum.Checked;
        MyCalendar.JpnFiscalYear := CheckBox_JpnFiscalYear.Checked;
        EMF := MyCalendar.MakeEMF;
      finally
        MyCalendar.Free;
      end;

      Printer.BeginDoc;
      try
        if bProportional then
        begin
          // 印刷領域に合わせて伸縮する
          PrintRect := Classes.Rect(0, 0, Printer.PageWidth, Printer.PageHeight);
          // 縦横調整していないので、用紙が横向きだと文字が横に伸びてしまいます
        end
        else
        begin
          // 端っこの非印刷領域も合わせてA4サイズなので、
          // 用紙の端までの領域を計算する
          PrintRect := Printer.PaperSize.PaperRect.PhysicalRect;
          OffsetRect(PrintRect,
            -Printer.PaperSize.PaperRect.WorkRect.Left,
            -Printer.PaperSize.PaperRect.WorkRect.Top);
        end;

        Windows.PlayEnhMetaFile(Printer.Canvas.Handle, EMF, PrintRect);
      finally
        Printer.EndDoc;
      end;
    finally
      Windows.DeleteEnhMetaFile(EMF);
    end;
  end;
end;

function TForm1.DoSaveToFile(FileName: string): Boolean;
var
  Data: mydataUtils.TMyData;
  Item: mydataUtils.TMyDataItem;
  MyCardLabel: CardUnit.TMyCardLabel;
  MyCardImage: CardUnit.TMyCardImage;
  MyCardShape: CardUnit.TMyCardShape;
  I: Integer;
  FileExt: string;
begin
  Result := FALSE;
  Data := TMyData.Create;
  try
    Data.Header.Values['ApplicationTitle'] := Application.Title;

    for I := 0 to FMyCard.Count - 1 do
    begin
      if FMyCard[I] is TMyCardLabel then
      begin
        MyCardLabel := TMyCardLabel(FMyCard[I]);
        Item := TMyDataItem.Create(Data);
        Item.Header.Values['ItemName'] := MyCardLabel.ItemName;
        Item.Header.Values['ClassName'] := MyCardLabel.ClassName;
        Item.Header.Values['Left'] := IntToStr(MyCardLabel.Left);
        Item.Header.Values['Top'] := IntToStr(MyCardLabel.Top);
        Item.Header.Values['Width'] := IntToStr(MyCardLabel.Width);
        Item.Header.Values['Height'] := IntToStr(MyCardLabel.Height);
        Item.Header.Values['Caption'] := MyCardLabel.Caption;
        Item.Header.Values['Alignment'] := IntToStr(Integer(MyCardLabel.Alignment));
        Item.Header.Values['Layout'] := IntToStr(Integer(MyCardLabel.Layout));

        Item.Header.Values['FontName'] := MyCardLabel.Font.Name;
        //Item.Header.Values['FontSize'] := IntToStr(MyCardLabel.Font.Size);
        Item.Header.Values['FontSize'] := Format('%.1f', [MyCardLabel.Font.Size * 0.5]);
        Item.Header.Values['FontStyle'] := IntToStr(Integer(MyCardLabel.Font.Style));
        Item.Header.Values['FontColor'] := IntToStr(Integer(MyCardLabel.Font.Color));
      end
      else if FMyCard[I] is TMyCardImage then
      begin
        MyCardImage := TMyCardImage(FMyCard[I]);
        Item := TMyDataItem.Create(Data);
        Item.Header.Values['ItemName'] := MyCardImage.ItemName;
        Item.Header.Values['ClassName'] := MyCardImage.ClassName;
        Item.Header.Values['Left'] := IntToStr(MyCardImage.Left);
        Item.Header.Values['Top'] := IntToStr(MyCardImage.Top);
        Item.Header.Values['Width'] := IntToStr(MyCardImage.Width);
        Item.Header.Values['Height'] := IntToStr(MyCardImage.Height);
        if Assigned(MyCardImage.Picture.Graphic) then
        begin
          if Assigned(MyCardImage.Picture.Jpeg) then
            FileExt := '.jpg'
          else if Assigned(MyCardImage.Picture.PNG) then
            FileExt := '.png'
          else if Assigned(MyCardImage.Picture.PNM) then
            FileExt := '.pnm'
          else if Assigned(MyCardImage.Picture.Bitmap) then
            FileExt := '.bmp'
          else if Assigned(MyCardImage.Picture.Icon) then
            FileExt := '.ico'
          else
            FileExt := '';
          if FileExt <> '' then
            Item.Header.Values['FileExt'] := FileExt;
          MyCardImage.Picture.Graphic.SaveToStream(Item.Body);
        end;
      end
      else if FMyCard[I] is TMyCardShape then
      begin
        MyCardShape := TMyCardShape(FMyCard[I]);
        Item := TMyDataItem.Create(Data);
        Item.Header.Values['ItemName'] := MyCardShape.ItemName;
        Item.Header.Values['ClassName'] := MyCardShape.ClassName;
        Item.Header.Values['Left'] := IntToStr(MyCardShape.Left);
        Item.Header.Values['Top'] := IntToStr(MyCardShape.Top);
        Item.Header.Values['Width'] := IntToStr(MyCardShape.Width);
        Item.Header.Values['Height'] := IntToStr(MyCardShape.Height);

        Item.Header.Values['Shape'] := IntToStr(Integer(MyCardShape.Shape));
        Item.Header.Values['PenColor'] := IntToStr(Integer(MyCardShape.Pen.Color));
        Item.Header.Values['PenStyle'] := IntToStr(Integer(MyCardShape.Pen.Style));
        Item.Header.Values['PenWidth'] := IntToStr(MyCardShape.Pen.Width);
        Item.Header.Values['BrushColor'] := IntToStr(Integer(MyCardShape.Brush.Color));
        Item.Header.Values['BrushStyle'] := IntToStr(Integer(MyCardShape.Brush.Style));
      end;
    end;// for I := 0 to Panel_Card.ControlCount - 1 do
    Result := Data.SaveToFile(FileName);
  finally
    Data.Free;
  end;
end;

function TForm1.DoLoadFromFile(FileName: string): Boolean;
var
  Data: mydataUtils.TMyData;
  I: Integer;
  S, FileExt: string;
  Item: mydataUtils.TMyDataItem;
  MyCardLabel: CardUnit.TMyCardLabel;
  MyCardImage: CardUnit.TMyCardImage;
  MyCardShape: CardUnit.TMyCardShape;
begin
  Result := FALSE;

  Data := TMyData.Create;
  try
    if Data.LoadFromFile(FileName) then
    begin
      FMyCard.Clear;

      for I := 0 to Data.Count - 1 do
      begin
        Item := Data.Items[I];
        S := Item.Header.Values['ClassName'];
        if S = 'TMyCardLabel' then
        begin
          MyCardLabel := Self.Add_MyCardLabel(FALSE);
          MyCardLabel.SetBounds(
            StrToIntDef(Item.Header.Values['Left'],    0),
            StrToIntDef(Item.Header.Values['Top'],     0),
            StrToIntDef(Item.Header.Values['Width'],  80),
            StrToIntDef(Item.Header.Values['Height'], 24));
          S := Item.Header.Values['ItemName'];
          if S <> '' then
            MyCardLabel.ItemName := S;
          S := Item.Header.Values['Caption'];
          if S <> '' then
            MyCardLabel.Caption := S;
          MyCardLabel.Alignment :=
            TAlignment(StrToIntDef(Item.Header.Values['Alignment'], Integer(MyCardLabel.Alignment)));
          MyCardLabel.Layout :=
            TTextLayout(StrToIntDef(Item.Header.Values['Layout'], Integer(MyCardLabel.Layout)));

          MyCardLabel.Font.Name := Item.Header.Values['FontName'];
          MyCardLabel.Font.Size :=
            //StrToIntDef(Item.Header.Values['FontSize'], MyCardLabel.Font.Size);
            Round(StrToFloatDef(Item.Header.Values['FontSize'], MyCardLabel.Font.Size * 0.5) * 2);
          MyCardLabel.Font.Style :=
            TFontStyles(StrToIntDef(Item.Header.Values['FontStyle'], Integer(MyCardLabel.Font.Style)));
          MyCardLabel.Font.Color :=
            TColor(StrToIntDef(Item.Header.Values['FontColor'], Integer(MyCardLabel.Font.Color)));
        end
        else if S = 'TMyCardImage' then
        begin
          MyCardImage := Self.Add_MyCardImage(FALSE);
          MyCardImage.SetBounds(
            StrToIntDef(Item.Header.Values['Left'],    0),
            StrToIntDef(Item.Header.Values['Top'],     0),
            StrToIntDef(Item.Header.Values['Width'],  64),
            StrToIntDef(Item.Header.Values['Height'], 64));
          S := Item.Header.Values['ItemName'];
          if S <> '' then
            MyCardImage.ItemName := S;

          FileExt := Item.Header.Values['FileExt'];
          if FileExt <> '' then
            MyCardImage.Picture.LoadFromStreamWithFileExt(
              Item.Body, FileExt)
          else
            MyCardImage.Picture.LoadFromStream(Item.Body);
          MyCardImage.Picture.Graphic.Transparent := TRUE;
        end
        else if S = 'TMyCardShape' then
        begin
          MyCardShape := Self.Add_MyCardShape(FALSE);
          MyCardShape.SetBounds(
            StrToIntDef(Item.Header.Values['Left'],    0),
            StrToIntDef(Item.Header.Values['Top'],     0),
            StrToIntDef(Item.Header.Values['Width'],  64),
            StrToIntDef(Item.Header.Values['Height'], 64));
          S := Item.Header.Values['ItemName'];
          if S <> '' then
            MyCardShape.ItemName := S;

          MyCardShape.Shape := StrToIntDef(Item.Header.Values['Shape'], Integer(stEllipse));
          MyCardShape.Pen.Color := TColor(StrToIntDef(Item.Header.Values['PenColor'], Integer(clBlack)));
          MyCardShape.Pen.Style := TFPPenStyle(StrToIntDef(Item.Header.Values['PenStyle'], Integer(psSolid)));
          MyCardShape.Pen.Width := StrToIntDef(Item.Header.Values['PenWidth'], 1);
          MyCardShape.Brush.Color := TColor(StrToIntDef(Item.Header.Values['BrushColor'], Integer(clWhite)));
          MyCardShape.Brush.Style := TFPBrushStyle(StrToIntDef(Item.Header.Values['BrushStyle'], Integer(bsClear)));
        end;
      end;
      Result := TRUE;
    end;
  finally
    Data.Free;
  end;

  FMyCard.SelectedItem := nil;
  PaintBox_Resizer.Hide;
end;

function TForm1.Add_MyCardLabel(Selected: Boolean): TMyCardLabel;
begin
  Result := TMyCardLabel.Create();
  FMyCard.Add(Result);
  Result.SetBounds(0, 0, 1200, 300);
  Result.ItemName := 'Label Name';
  Result.Caption := 'New Label';
  Result.Alignment := taLeftJustify;
  Result.Layout := tlCenter;
  Result.OnMouseDown := @CardItem_MouseDown;
  Result.OnMouseMove := @CardItem_MouseMove;
  Result.OnMouseUp := @CardItem_MouseUp;
  Result.OnClick := @CardItem_Click;
  Result.OnDblClick := @CardItem_DblClick;
  Result.OnInvalidate := @CardItem_Invalidate;
  //Result.PopupMenu := PopupMenu_Card;
  if Selected then
  begin
    FMyCard.SelectedItem := Result;
    PaintBox_Resizer.BoundsRect := HiMetricToClient(Result.BoundsRect);
    PaintBox_Resizer.BringToFront;
    PaintBox_Resizer.Show;
  end;
end;

function TForm1.Add_MyCardImage(Selected: Boolean): TMyCardImage;
begin
  Result := TMyCardImage.Create();
  FMyCard.Add(Result);
  //Result.Parent := Panel_Card;
  Result.SetBounds(0, 0, 1000, 1000);
  Result.ItemName := 'Image Name';
  Result.OnMouseDown := @CardItem_MouseDown;
  Result.OnMouseMove := @CardItem_MouseMove;
  Result.OnMouseUp := @CardItem_MouseUp;
  Result.OnClick := @CardItem_Click;
  Result.OnDblClick := @CardItem_DblClick;
  Result.OnInvalidate := @CardItem_Invalidate;
  //Result.PopupMenu := PopupMenu_Card;
  if Selected then
  begin
    FMyCard.SelectedItem := Result;
    PaintBox_Resizer.BoundsRect := HiMetricToClient(Result.BoundsRect);
    PaintBox_Resizer.BringToFront;
    PaintBox_Resizer.Show;
  end;
end;

function TForm1.Add_MyCardShape(Selected: Boolean): TMyCardShape;
begin
  Result := TMyCardShape.Create();
  FMyCard.Add(Result);

  Result.SetBounds(0, 0, 1000, 1000);
  Result.ItemName := 'Shape Name';
  Result.OnMouseDown := @CardItem_MouseDown;
  Result.OnMouseMove := @CardItem_MouseMove;
  Result.OnMouseUp := @CardItem_MouseUp;
  Result.OnClick := @CardItem_Click;
  Result.OnDblClick := @CardItem_DblClick;
  Result.OnInvalidate := @CardItem_Invalidate;

  if Selected then
  begin
    FMyCard.SelectedItem := Result;
    PaintBox_Resizer.BoundsRect := HiMetricToClient(Result.BoundsRect);
    PaintBox_Resizer.BringToFront;
    PaintBox_Resizer.Show;
  end;
end;

procedure TForm1.CardItem_MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Sender is TMyCardItem then
  begin
    //
  end;
end;

procedure TForm1.CardItem_MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Sender is TMyCardItem then
  begin
    //
  end;
end;

procedure TForm1.CardItem_MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Sender is TMyCardItem then
  begin
    //
  end;
end;

procedure TForm1.CardItem_Click(Sender: TObject);
var
  R: TRect;
begin
  if Sender is TMyCardItem then
  begin
    if Sender <> FMyCard.SelectedItem then
      FMyCard.SelectedItem := Sender as TMyCardItem;
    R := TMyCardItem(Sender).BoundsRect;
    R.Left := R.Left * PaintBox_Card.ClientWidth div 9100;
    R.Top := R.Top * PaintBox_Card.ClientHeight div 5500;
    R.Right := R.Right * PaintBox_Card.ClientWidth div 9100;
    R.Bottom := R.Bottom * PaintBox_Card.ClientHeight div 5500;
    R.Right := R.Right + 1; R.Bottom := R.Bottom + 1;
    PaintBox_Resizer.BoundsRect := R;
    PaintBox_Resizer.BringToFront;
    PaintBox_Resizer.Show;
  end;
end;

procedure TForm1.CardItem_DblClick(Sender: TObject);
begin
  if Sender is TMyCardItem then
  begin
    //
  end;
end;

procedure TForm1.CardItem_Invalidate(Sender: TObject);
begin
  PaintBox_Card.Invalidate;
end;

procedure TForm1.SetZoom_Card(AValue: Integer);
var
  I, W, H: Integer;
  E: Extended;
  iLogpixelsX, iLogpixelsY: Integer;
const
  ZOOM_MAX = 30;
  ZOOM_MIN = -5;
begin
  I := AValue;
  if I < ZOOM_MIN then
    I := ZOOM_MIN;
  if I > ZOOM_MAX then
    I := ZOOM_MAX;
  Panel_Card.Tag := I;
  E := Power(2, I / 10);

  iLogpixelsX  := GetDeviceCaps(Canvas.Handle, LOGPIXELSX); // 水平解像度
  iLogpixelsY  := GetDeviceCaps(Canvas.Handle, LOGPIXELSY); // 垂直解像度
  W := Round(E * 95 / 25.4 * iLogpixelsX);
  H := Round(E * 55 / 25.4 * iLogpixelsY);
  Panel1.ClientWidth := W + 4;
  Panel1.ClientHeight := H + 4;
  Panel_Card.ClientWidth := W;
  Panel_Card.ClientHeight := H;

  StatusBar1.SimpleText := Format('Zoom: %.1f %%, (%d)', [E * 100, I]);
end;

procedure TForm1.CardItem_PropertyChange(Sender: TObject);
var
  MyCardItem: TMyCardItem;
begin
  MyCardItem := FMyCard.SelectedItem;
  if Assigned(MyCardItem) then
  if(MyCardItem is TMyCardLabel)and(Sender = LabelPropertyForm)and
    LabelPropertyForm.Visible then
  begin
    TMyCardLabel(MyCardItem).Caption := LabelPropertyForm.Text;
    TMyCardLabel(MyCardItem).Font := LabelPropertyForm.Font;
    TMyCardLabel(MyCardItem).Alignment := LabelPropertyForm.Alignment;
    TMyCardLabel(MyCardItem).Layout := LabelPropertyForm.Layout;
  end
  else if(MyCardItem is TMyCardShape)and(Sender = ShapePropertyForm)and
    ShapePropertyForm.Visible then
  begin
    TMyCardShape(MyCardItem).Pen := ShapePropertyForm.Pen;
    TMyCardShape(MyCardItem).Brush := ShapePropertyForm.Brush;
    TMyCardShape(MyCardItem).Shape := ShapePropertyForm.Shape;
  end;
end;

procedure TForm1.Action_FileExitExecute(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Action_EditLabelExecute(Sender: TObject);
var
  MyCardItem: TMyCardItem;
  Caption_Tmp: string;
  Font_Tmp: TFont;
  Alignment_Tmp: TAlignment;
  Layout_Tmp: TTextLayout;
  S: string;
begin
  MyCardItem := FMyCard.SelectedItem;
  if Assigned(MyCardItem)and(MyCardItem is TMyCardLabel) then
  begin
    Font_Tmp := TFont.Create;
    try
      Caption_Tmp := TMyCardLabel(MyCardItem).Caption;
      Font_Tmp.Assign(TMyCardLabel(MyCardItem).Font);
      Alignment_Tmp := TMyCardLabel(MyCardItem).Alignment;
      Layout_Tmp := TMyCardLabel(MyCardItem).Layout;

      LabelPropertyForm.OnPropertyChange := nil;
      LabelPropertyForm.Text := TMyCardLabel(MyCardItem).Caption;
      LabelPropertyForm.Font := TMyCardLabel(MyCardItem).Font;
      LabelPropertyForm.Alignment := TMyCardLabel(MyCardItem).Alignment;
      LabelPropertyForm.Layout := TMyCardLabel(MyCardItem).Layout;
      LabelPropertyForm.OnPropertyChange := @CardItem_PropertyChange;

      if LabelPropertyUnit.LabelPropertyForm.ShowModal = mrOk then
      begin
        S := Trim(LabelPropertyUnit.LabelPropertyForm.Text);
        if S = '' then
        begin
          PaintBox_Resizer.Hide;
          FMyCard.Remove(MyCardItem);
          ShowMessage('ラベルを削除しました');
        end
        else
        begin
          TMyCardLabel(MyCardItem).Caption := LabelPropertyUnit.LabelPropertyForm.Text;
          TMyCardLabel(MyCardItem).Font := LabelPropertyUnit.LabelPropertyForm.Font;
          TMyCardLabel(MyCardItem).Alignment := LabelPropertyUnit.LabelPropertyForm.Alignment;
          TMyCardLabel(MyCardItem).Layout := LabelPropertyUnit.LabelPropertyForm.Layout;
          TMyCardLabel(MyCardItem).Invalidate;
        end;
      end
      else
      begin
        TMyCardLabel(MyCardItem).Caption := Caption_Tmp;
        TMyCardLabel(MyCardItem).Font := Font_Tmp;
        TMyCardLabel(MyCardItem).Alignment := Alignment_Tmp;
        TMyCardLabel(MyCardItem).Layout := Layout_Tmp;
      end;
      LabelPropertyForm.OnPropertyChange := nil;
    finally
      Font_Tmp.Free;
    end;
  end;
end;

procedure TForm1.Action_EditAddLabelExecute(Sender: TObject);
var
  S: string;
begin
  S := Trim(InputBox('ラベルの追加', 'ラベルの文字', 'New Label'));
  if S <> '' then
    Add_MyCardLabel.Caption := S;
end;

procedure TForm1.Action_EditAddShapeExecute(Sender: TObject);
begin
  Add_MyCardShape.Shape := Integer(stEllipse);
end;

procedure TForm1.Action_EditBringToFrontExecute(Sender: TObject);
var
  MyCardItem: TMyCardItem;
begin
  MyCardItem := FMyCard.SelectedItem;
  if Assigned(MyCardItem) then
  begin
    FMyCard.BringToFront(MyCardItem);
    PaintBox_Resizer.Invalidate;
  end;
end;

procedure TForm1.Action_EditDeleteItemExecute(Sender: TObject);
var
  MyCardItem: TMyCardItem;
begin
  MyCardItem := FMyCard.SelectedItem;
  if Assigned(MyCardItem) then
  if Application.MessageBox('選択している項目を削除しますか？',
    PChar(String(MyCardItem.ClassName)),
    MB_ICONQUESTION or MB_YESNO or MB_DEFBUTTON2) = IDYES then
  begin
    PaintBox_Resizer.Hide;
    FMyCard.SelectedItem := nil;
    FMyCard.Remove(MyCardItem);
  end;
end;

procedure TForm1.Action_EditAddImageExecute(Sender: TObject);
var
  FS: LazUTF8Classes.TFileStreamUTF8;
  FileExt: string;
begin
  if OpenPictureDialog1.Execute then
  begin
    FS := TFileStreamUTF8.Create(OpenPictureDialog1.FileName, fmOpenRead or fmShareDenyNone);
    try
      FileExt := ExtractFileExt(OpenPictureDialog1.FileName);
      Add_MyCardImage.Picture.LoadFromStreamWithFileExt(FS, FileExt);
    finally
      FS.Free;
    end;
  end;
end;

procedure TForm1.Action_EditPictureExecute(Sender: TObject);
var
  MyCardItem: TMyCardItem;
  Stream: LazUTF8Classes.TFileStreamUTF8;
  FileExt: string;
begin
  MyCardItem := FMyCard.SelectedItem;
  if Assigned(MyCardItem)and(MyCardItem is TMyCardImage)then
  begin
    OpenPictureDialog1.Title := 'イメージの読込み';
    if OpenPictureDialog1.Execute then
    begin
      {
      (Sender as).Picture.LoadFromFile(OpenPictureDialog1.FileName);
      // Lazarusバージョン1.6は、上記のコードで日本語のパス＋ファイル名も大丈夫っぽいですね。
      }
      // バージョン1.4.x以前では、日本語のパス＋ファイル名に対応するために、
      // UTF-8に対応したストリームを経由して読み込む必要があります。
      Stream := LazUTF8Classes.TFileStreamUTF8.Create(
        OpenPictureDialog1.FileName, fmOpenRead or fmShareDenyNone);
      try
        FileExt := ExtractFileExt(OpenPictureDialog1.FileName);
        TMyCardImage(MyCardItem).Picture.LoadFromStreamWithFileExt(
          Stream, FileExt);
        MyCardItem.Invalidate;
      finally
        Stream.Free;
      end;
    end;
  end;
end;

procedure TForm1.Action_EditSendToBackExecute(Sender: TObject);
var
  MyCardItem: TMyCardItem;
begin
  MyCardItem := FMyCard.SelectedItem;
  if Assigned(MyCardItem) then
  begin
    FMyCard.SendToBack(MyCardItem);
    PaintBox_Resizer.Invalidate;
  end;
end;

procedure TForm1.Action_EditShapeExecute(Sender: TObject);
var
  MyCardItem: TMyCardItem;
  Shape_Tmp: TMyCardShape;
begin
  MyCardItem := FMyCard.SelectedItem;
  if Assigned(MyCardItem)and(MyCardItem is TMyCardShape) then
  begin
    Shape_Tmp := TMyCardShape.Create();
    try
      Shape_Tmp.Shape := TMyCardShape(MyCardItem).Shape;
      Shape_Tmp.Pen := TMyCardShape(MyCardItem).Pen;
      Shape_Tmp.Brush := TMyCardShape(MyCardItem).Brush;

      ShapePropertyForm.OnPropertyChange := nil;
      ShapePropertyForm.Shape := TMyCardShape(MyCardItem).Shape;
      ShapePropertyForm.Pen := TMyCardShape(MyCardItem).Pen;
      ShapePropertyForm.Brush := TMyCardShape(MyCardItem).Brush;
      ShapePropertyForm.Brush.Style := TMyCardShape(MyCardItem).Brush.Style;
      ShapePropertyForm.OnPropertyChange := @CardItem_PropertyChange;

      if ShapePropertyUnit.ShapePropertyForm.ShowModal = mrOk then
      begin
        TMyCardShape(MyCardItem).Pen := ShapePropertyUnit.ShapePropertyForm.Pen;
        TMyCardShape(MyCardItem).Brush := ShapePropertyUnit.ShapePropertyForm.Brush;
        TMyCardShape(MyCardItem).Shape := ShapePropertyUnit.ShapePropertyForm.Shape;
        TMyCardShape(MyCardItem).Invalidate;
      end
      else
      begin
        TMyCardShape(MyCardItem).Pen := Shape_Tmp.Pen;
        TMyCardShape(MyCardItem).Brush := Shape_Tmp.Brush;
        TMyCardShape(MyCardItem).Shape := Shape_Tmp.Shape;
      end;
      ShapePropertyForm.OnPropertyChange := nil;
    finally
      Shape_Tmp.Free;
    end;
  end;
end;

procedure TForm1.Action_FileExportExecute(Sender: TObject);
var
  MyCalendar: TMyCalendar;
begin
  if SaveDialog_Export.Execute then
  begin
    if PageControl1.ActivePage = TabSheet_Calendar then
    begin
      MyCalendar := TMyCalendar.Create(StrToIntDef(ComboBox_Year.Text, 0));
      try
        MyCalendar.Lang := ComboBox_Lang.ItemIndex;
        MyCalendar.WeekNum := CheckBox_WeekNum.Checked;
        MyCalendar.JpnFiscalYear := CheckBox_JpnFiscalYear.Checked;
        MyCalendar.MakeEMFFile(SaveDialog_Export.FileName);
      finally
        MyCalendar.Free;
      end;
    end
    else if PageControl1.ActivePage = TabSheet_Card then
    begin
      FMyCard.MakeEMFFile(SaveDialog_Export.FileName);
    end
    else
      ShowMessage('unknown error in Action_FileExportExecute');
    SaveDialog_Export.InitialDir := ExtractFilePath(SaveDialog_Export.FileName);
    SaveDialog_Export.FileName := ExtractFileName(SaveDialog_Export.FileName);
  end;
end;

procedure TForm1.Action_FileOpenExecute(Sender: TObject);
begin
  if OpenDialog_Data.Execute then
  begin
    OpenDialog_Data.InitialDir := ExtractFilePath(OpenDialog_Data.FileName);
    OpenDialog_Data.FileName := ExtractFileName(OpenDialog_Data.FileName);
    SaveDialog_Data.InitialDir := OpenDialog_Data.InitialDir;
    SaveDialog_Data.FileName := OpenDialog_Data.FileName;
    if DoLoadFromFile(OpenDialog_Data.FileName) then
    else
      ShowMessage('データの読込みに失敗しました');
  end;
end;

procedure TForm1.Action_FilePrintExecute(Sender: TObject);
begin
  if PageControl1.ActivePage = TabSheet_Card then
    DoPrint_Card_EMF
    //DoPrint_Card
  else if PageControl1.ActivePage = TabSheet_Calendar then
    DoPrint_Calendar_EMF;
end;

procedure TForm1.Action_FileSaveExecute(Sender: TObject);
begin
  if SaveDialog_Data.Execute then
  begin
    SaveDialog_Data.InitialDir := ExtractFilePath(SaveDialog_Data.FileName);
    SaveDialog_Data.FileName := ExtractFileName(SaveDialog_Data.FileName);
    if DoSaveToFile(SaveDialog_Data.FileName) then
    else
      ShowMessage('データの保存に失敗しました');
  end;
end;

procedure TForm1.Action_PageBackwardExecute(Sender: TObject);
var
  I: Integer;
begin
  I := PageControl1.ActivePageIndex - 1;
  if I < 0 then
    PageControl1.ActivePageIndex := PageControl1.PageCount - 1
  else
    PageControl1.ActivePageIndex := I;
end;

procedure TForm1.Action_PageForwardExecute(Sender: TObject);
var
  I: Integer;
begin
  I := PageControl1.ActivePageIndex + 1;
  if I >= PageControl1.PageCount then
    PageControl1.ActivePageIndex := 0
  else
    PageControl1.ActivePageIndex := I;
end;

procedure TForm1.Action_ViewZoomDownExecute(Sender: TObject);
begin
  if PageControl1.ActivePage = TabSheet_Card then
  begin
    SetZoom_Card(Panel_Card.Tag - 1);
    FMyCard.SelectedItem := nil;
    PaintBox_Resizer.Hide;
  end;
end;

procedure TForm1.Action_ViewZoomUpExecute(Sender: TObject);
begin
  if PageControl1.ActivePage = TabSheet_Card then
  begin
    SetZoom_Card(Panel_Card.Tag + 1);
    FMyCard.SelectedItem := nil;
    PaintBox_Resizer.Hide;
  end;
end;

procedure TForm1.CheckBox_JpnFiscalYearChange(Sender: TObject);
begin
  PaintBox_Calendar.Invalidate;
end;

procedure TForm1.CheckBox_WeekNumChange(Sender: TObject);
begin
  PaintBox_Calendar.Invalidate;
end;

procedure TForm1.ComboBox_LangChange(Sender: TObject);
begin
  PaintBox_Calendar.Invalidate;
end;

procedure TForm1.ComboBox_YearChange(Sender: TObject);
begin
  PaintBox_Calendar.Invalidate;
end;

end.

